import { login, logout, getInfo } from '@/api/user/login';
import { getToken, setToken, removeToken } from '@/api/user/auth';
import { Message } from 'element-ui'

let that=this
const user = {
  state: {
    token: getToken(),
    name: '',
    avatar: '',
    roles: [],
    permissions: []
  },

  mutations: {
    SET_TOKEN: (state, token) => {
      state.token = token;
    },
    SET_NAME: (state, name) => {
      state.name = name;
    },
    // SET_AVATAR: (state, avatar) => {
    //   state.avatar = avatar;
    // },
    SET_ROLES: (state, roles) => {
      state.roles = roles;
    },
    SET_PERMISSIONS: (state, permissions) => {
      state.permissions = permissions;
    }
  },

  actions: {
    // 登录
    Login (userInfo) {
      console.log(userInfo);
      const username = userInfo.userName;
      const password = userInfo.password;
      // let that = this;
      return new Promise((resolve, reject) => {
        login(username, password).then(res => {
          console.log(res)
          if (res.code==1) {
            setToken(res.data.token);
            sessionStorage.setItem('access_token', res.data.token);
            sessionStorage.setItem('SET_NAME', res.data.username);
            sessionStorage.setItem('SET_ID', res.data.user_id);
            sessionStorage.setItem('SET_Account', res.data.login);
            sessionStorage.setItem('SET_operator', res.data.operator);
            sessionStorage.setItem('SET_admin', res.data.admin);
            sessionStorage.setItem('image_url', res.data.image_url);
            Message({
              message:'登录成功',
              type: 'success'
            });
            resolve();
          } else {
            Message({
              message:'用户名或密码错误',
              type: 'error'
            });
            reject(false);
          }
        }).catch(error => {
          Message({
            message:'用户名或密码错误',
            type: 'error'
          });
          reject(error);
        });
      });
    },

    // 获取用户信息
    GetInfo ({ commit, state }) {
      return new Promise((resolve, reject) => {
        getInfo(state.token).then(res => {
          sessionStorage.setItem('SET_NAME', res.data.username);
            sessionStorage.setItem('SET_ID', res.data.user_id);
            sessionStorage.setItem('SET_Account', res.data.login);
            sessionStorage.setItem('SET_operator', res.data.operator);
            sessionStorage.setItem('SET_admin', res.data.admin);
            sessionStorage.setItem('image_url', res.data.image_url);
          // commit('SET_AVATAR', avatar);
          resolve(res);
        }).catch(error => {
          reject(error);
        });
      });
    },

    // 退出系统
    LogOut ({ commit, state }) {
      return new Promise((resolve, reject) => {
        logout(state.token).then(() => {
          commit('SET_TOKEN', '');
          commit('SET_ROLES', []);
          commit('SET_PERMISSIONS', []);
          removeToken();
          resolve();
        }).catch(error => {
          reject(error);
        });
      });
    },

    // 前端 登出
    FedLogOut ({ commit }) {
      return new Promise(resolve => {
        commit('SET_TOKEN', '');
        removeToken();
        resolve();
      });
    }
  }
};

export default user;
