import axios from 'axios';
// import router from './router';
import { getToken, setToken, removeToken } from '@/api/user/auth';
// import { refrechGetInfo } from '@/api/user/login';

// 创建axios实例
const service = axios.create({
  baseURL: process.env.BASE_API, // api的base_url
  timeout: 5000 // 请求超时时间
  // headers:{'X-Custom-Header': 'foobar'} // 请求头
});

// request拦截器
service.interceptors.request.use(config => {
  if (getToken()) {
    config.headers['Authorization'] = getToken(); // 让每个请求携带自定义token 请根据实际情况自行修改
    // config.headers['Authorization'] = 'autologin_forge_military=' + getToken(); // 让每个请求携带自定义token 请根据实际情况自行修改
  }
  return config;
}, error => {
  // Do something with request error
  console.log(error); // for debug
  Promise.reject(error);
});
let isRefreshing = false; // 标记是否正在刷新 token
let requests = []; // 存储待重发请求的数组
var that = this;
// respone拦截器
service.interceptors.response.use(
  
  response => {
    /**
     * 下面的注释为通过response自定义code来标示请求状态，当code返回如下情况为权限有问题，登出并返回到登录页
     * 如通过xmlhttprequest 状态码标识 逻辑可写在下面error中
     */
    const res = response;
    if (res.status === 400) {
      Message({
        message: '请求错误',
        type: 'error',
        duration: 5 * 1000
      });
      // eslint-disable-next-line prefer-promise-reject-errors
      return Promise.reject('error');
    }
    if (res.status === 401) {
      Message({
        message: '未授权，请登录！',
        type: 'error',
        duration: 5 * 1000
      });
      // eslint-disable-next-line prefer-promise-reject-errors
      return Promise.reject('error');
    }
    if (res.status === 40001) {
      Message({
        message: '账户或密码错误！',
        type: 'warning'
      });
      // eslint-disable-next-line prefer-promise-reject-errors
      return Promise.reject('error');
    }
    if (response.status !== 200 && res.status !== 200) {
      Message({
        message: res.message,
        type: 'error',
        duration: 7 * 1000
      });
    } else {
      return response.data;
    }
  },
  error => {
    if (error.response.status === 401 && !error.config.url.includes('/auth-server/oauth/token')) {
      removeToken();
      that.$router.push('/Login');
      // let responseData = error.response;
      // const { config } = error;
      // if (!isRefreshing) {
      //   isRefreshing = true;
      //   if (sessionStorage.getItem('refresh_token')) {
      //     console.log(sessionStorage.getItem('refresh_token'));
      //     refrechGetInfo(sessionStorage.getItem('refresh_token')).then(res => {
      //       if (res.access_token) {
      //         setToken(res.access_token);
      //         sessionStorage.setItem('access_token', res.access_token);
      //         sessionStorage.setItem('refresh_token', res.refresh_token);
      //         sessionStorage.setItem('SET_NAME', res.userName);
      //         sessionStorage.setItem('SET_ID', res.userId);
      //         const { access_token } = res.access_token;
      //         config.headers.Authorization = `Bearer ${access_token}`;
      //         // token 刷新后将数组的方法重新执行
      //         requests.forEach((cb) => cb(access_token));
      //         requests = []; // 重新请求完清空
      //         return service(config);
      //       } else {
      //         router.push('/Login');
      //         Message.error('登录失败');
      //         // return false;
      //       }
      //     });
      //   } else {
      //     console.log('21212')
      //     that.$router.push('/Login');
      //     // Message({
      //     //   message: '未授权，请登录！',
      //     //   type: 'error',
      //     //   duration: 5 * 1000
      //     // });
      //   }
      // }
    } else {
      that.$router.push('/Login');
    }
    return Promise.reject(error);
  }
);

export default service;
